#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cctype>

using namespace std;

int main(int argc, char *argv[])
{
	FILE *bac_genome, *fastq;
	char read[1000], exclude[1001], filename[101], number[10];
	unsigned int spot=2,contigs=1, length=atoi(argv[3]);
	bool split=false;
	if (argc > 4)
		split=true;
	bac_genome=fopen(argv[1], "r");
	if (split==false)
	{
		strcpy(filename, argv[2]);
		strcat(filename, ".fastq");
		fastq=fopen64(filename, "w");
	}
	else 
	{
		strcpy(filename, argv[2]);
		sprintf(number, "%d", contigs);
		strcat(filename, number);
		strcat(filename, ".fastq");
		fastq=fopen(filename, "w");
		contigs++;
	}
	fgets(exclude, 1000, bac_genome);
	read[length]='\0';
	for (int a=0; a<length; a++)
	{
		read[a]=fgetc(bac_genome);
		if (read[a]=='\n')
			read[a]=fgetc(bac_genome);
		read[a]=toupper(read[a]);
	}
	fprintf(fastq, "@1\n%s\n+\n",read);
	for (int ah=0; ah<length; ah++)
	  {
	    fprintf(fastq, "I");
	  }
	fprintf(fastq,"\n");
	while (!feof(bac_genome))
	{
	  for (int a=0; a<(length-1); a++)
			read[a]=read[a+1];
		read[length-1]=fgetc(bac_genome);
		while (read[length-1]=='\n')
		  read[length-1]=fgetc(bac_genome);
		if (read[length-1] != EOF)
		{
		  read[length-1]=toupper(read[length-1]);
		  fprintf(fastq, "@%u\n%s\n+\n",spot,read);
		  for (int ah=0; ah<length; ah++)
		    {
		      fprintf(fastq,"I");
		    }
		  fprintf(fastq, "\n");
		  spot++;
		}
		if (spot!=0 && spot%1000000==0)
			fprintf(stdout, "%d reads created.\n", spot);
	}
	if (split==false)
	{
		rewind(bac_genome);
		fgets(exclude, 1000, bac_genome);
		for (int a=0; a<(length-1); a++)
		{
			read[length-1]=fgetc(bac_genome);
			if (read[length-1]=='\n')
				read[length-1]=fgetc(bac_genome);
			read[length-1]=toupper(read[length-1]);
			fprintf(fastq, "@%u\n%s\n+\n",spot,read);
			for (int ah=0; ah<length; ah++)
			  {
			    fprintf(fastq, "I");
			  }
			fprintf(fastq, "\n");
			spot++;
			for (int b=0; b<(length-1); b++)
				read[b]=read[b+1];
		}
	}
	return 0;
}
